#include <stdlib.h>
#include <stdio.h>
#include <math.h>

int main(int iArg, char** cArg){
    
  FILE *file1, *file2, *file3=NULL;
    
  int a,b,iteration,i,imax,j,jmax,**iOszlop;
  double **eSzomszed,szumma;
  char cNev[100][10], cProcessname[50],cInput[30],cOutput[30];
  char cLabel; 

  /* Reading process name */ 

  if(iArg > 1){
    sscanf(cArg[1],"%s",cProcessname);
  }
  else{
    sprintf(cProcessname,"default");
  }
    
  cLabel = 0;

  if(iArg > 2){
    sscanf(cArg[2],"%s",cInput);
    if(cInput[0] == '-'){
      if(cInput[1] == 'l'){
	cLabel = 1;
      }
	    

    }
  }
  /* opening input files */
  sprintf(cInput,"%s_cols.log",cProcessname);
  if((file1=fopen(cInput,"r"))){
  }
  else{

    printf("Cannot open %s!\n",cInput);
  }

  if(cLabel == 1){

    sprintf(cInput,"%s_cols_lab.txt",cProcessname);
    file3=fopen(cInput,"r");
  }

  /* opening output files */

  sprintf(cOutput,"%s_colass.log",cProcessname);
  file2=fopen(cOutput,"w");

  /* Reading input files */

    
  fscanf(file1,"%d",&imax);
  fprintf(file2,"%d\n",imax);
  fscanf(file1,"%d",&jmax);
  fprintf(file2,"%d\n",jmax);
  fscanf(file1,"%d",&iteration);

    
  /* fajnevek beolvasasa es kiiratasa*/
  if(cLabel == 1){    
    
    for(i=0;i<jmax;i++){
      fscanf(file3,"%s",cNev[i]);
      fprintf(file2,"%s\n",cNev[i]);
    }
  }
  else{
    for(j=0;j<jmax;j++){
      fprintf(file2,"%d\n",j);
    }
  }

  /* Memoria allokacio az asszocialtsagokat tartalmazo matrixnak */ 

  eSzomszed = (double**) malloc(sizeof(double*)*jmax);
  for(j = 0; j < jmax; j++){
    eSzomszed[j] = (double*) malloc(sizeof(double)*jmax);
  }
  iOszlop = (int**) malloc(sizeof(int*)*iteration);
  for(j = 0; j < iteration; j++){
    iOszlop[j] = (int*) malloc(sizeof(int)*jmax);
  }
    
  for(i=0;i<iteration;i++){
    for(j=0;j<jmax;j++){	    
      fscanf(file1,"%d",&iOszlop[i][j]);
      /* fprintf(file2,"sor %d",i);
	 fprintf(file2,"iteracio %d",j);
	 fprintf(file2,"beolv %d\n",iOszlop[i][j]);*/
    }
  }
  for(a=0;a<jmax;a++){
    for(b=0;b<jmax;b++){
      eSzomszed[a][b]=0.0;
    }
  }
    
  for(i=0;i<iteration;i++){
    for(j=0;j<jmax-1;j++){
	    
      a=iOszlop[i][j];
      /*fprintf(file2,"a %d",a);*/
      b=iOszlop[i][j+1];
	    
      /*fprintf(file2,"b %d",b);*/
	    
      eSzomszed[a][b] += 1.0;
      eSzomszed[b][a] = eSzomszed[a][b];

      /*fprintf(file2,"szomszed %d\n", eSzomszed[a][b]);*/
    }
  }
  for(a = 0; a < jmax; a++){
    eSzomszed[a][a] = 0.00; 
  }
  for(b=0;b<jmax-1;b++){
    for(a=b+1;a<jmax;a++){
      eSzomszed[a][b]=((eSzomszed[a][b])/((double)(jmax-1.0)*(double)iteration))*(double)jmax;	
      eSzomszed[b][a]=eSzomszed[a][b]; 
    }
  }
  szumma=0;
  for(b=0;b<jmax-1;b++){
    for(a=b+1;a<jmax;a++){	    
      szumma+=eSzomszed[a][b];  
    }
  }
  for(a=0;a<jmax;a++){
    for(b=0;b<jmax;b++){
    
      /* fprintf(file2,"a %d",a);
	 fprintf(file2," b %d",b);*/
      fprintf(file2,"%f ",eSzomszed[a][b]);
    }
    fprintf(file2,"\n");
  }
  fprintf(file2,"szumma %f",szumma);
  for(j = 0; j < jmax; j++){
    free(eSzomszed[j]);
  }
  for(j = 0; j < iteration; j++){
    free(iOszlop[j]);
  }
  free(eSzomszed);
  free(iOszlop);
  return(0);   
}			 
