/*

2004 aprilis : hatarszamok tukrozve
konstans belovasasi lehetosegek koztuk valaszthato, hogy megadunk-e homersekletet
permutacios fajl van-e


kiiratjuk az imaxot es jmaxot is a sorpermutacios es oszloppermutacios fajlba 
iIteration s iTotalsample felcserlve 

*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 
#define MAX 1000
#define TOTALSAMPLE 1500
#define ITERATION 1000
#define T 1.0

long int random();

int main(int iArg, char** cArg){

  void srandom(unsigned int);
  FILE *file1, *file2,*file3,*file4,*file5=NULL; 
  int iMatrix[MAX][MAX],i,j,k,iSor[MAX],iOszlop[MAX],iSorNew[MAX],iOszlopNew[MAX],s,o; 
  int imax,jmax,c=0,m=0,iI; 
  int iIntrand(int);
  double eEnergy(int[MAX][MAX],int,int,int[MAX],int[MAX]); 
  double eX,eEnergyOld,eEnergyNew;
  double eProposalsor(int[MAX][MAX],int[MAX],int[MAX],int,int);
  double eProposaloszlop(int[MAX][MAX],int[MAX],int[MAX],int,int); 
  double eSordiff,eOszlopdiff;
  double eTo,eT; /*eTo=eredeti, begepelt homerseklet, eT a homersekleti valtozo*/
  long int iTemp, iBurnin, iTotalsample, iIteration;
  char cProcessname[50], cInput[30],cOutput[30];
  char cPermutacio;
    
  /* Reading process name*/
    
  if(iArg>1){
    sscanf(cArg[1],"%s",cProcessname);
  }
  else{
    sprintf(cProcessname,"default");
  }
    
    
  /* Initializing */
  eTo = T;
  iBurnin = 500;
  iTotalsample = TOTALSAMPLE;
  iIteration = ITERATION;
  cPermutacio = 0;
    
  /* a konstansok es permutacio beolvasasa */
    
  iI = 2;
  while(iI<iArg){
    sscanf(cArg[iI],"%s",cInput);
    if(cInput[0] == '-'){
      if(cInput[1] == 'p'){
	cPermutacio = 1;
      }
      else if(cInput[1] == 'B'){
	if((iI + 1) < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing burnin number!\n");
	  }
	  else{
	    sscanf(cInput,"%ld",&iBurnin);
	    iI++;
	  }
	}
	else{
	  printf("Missing burnin number!\n");
	}
      }
      else if(cInput[1] == 't'){
	if((iI + 1) < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing temperature!\n");
	  }
	  else{
	    sscanf(cInput,"%lf",&eTo);
	    printf("%f",eTo);
	    iI++;
	  }
	}
	else{
	  printf("Missing temperature!\n");
	}
      }
      else if(cInput[1] == 'T'){
	if((iI + 1) < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing number of total samples!\n");
	  }
	  else{
	    sscanf(cInput,"%ld",&iTotalsample);
	    iI++;
	  }
	}
	else{
	  printf("Missing number of total samples!\n");
	}
      }
      else if(cInput[1] == 'I'){
	if((iI + 1) < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing number of iterations!\n");
	  }
	  else{
	    sscanf(cInput,"%ld",&iIteration);
	    iI++;
	  }
	}
	else{
	  printf("Missing number of iterations!\n");
	}
      }

      else{
	printf("Unknown command! %s\n", cArg[iI]);
      }
    }
    else{
      printf("Unknown command! %s\n", cArg[iI]);
    }
    iI++;
  }
    
  /* opening output files */
  sprintf(cOutput,"%s_out.log",cProcessname);
  file2 = fopen(cOutput,"w");
  sprintf(cOutput,"%s_rows.log",cProcessname);
  file3 = fopen(cOutput,"w");
  sprintf(cOutput,"%s_cols.log",cProcessname);
  file4 = fopen(cOutput,"w");

  /* ha van a permutacios fajl megnyitasa */

  if(cPermutacio == 1){
    sprintf(cInput,"%s_perm.txt",cProcessname);
    printf("This is the cInput %s\n",cInput);	
    file5 = fopen(cInput,"r");
  }
   
    
  /* Reading matrix */
    
  sprintf(cInput,"%s_matrix.dat",cProcessname);
  file1 = fopen(cInput,"r"); 
  fscanf(file1,"%d",&imax); 
  fscanf(file1,"%d",&jmax); 
  for(i=0;i<imax;i++){ 
    for(j=0;j<jmax;j++){ 
      fscanf(file1,"%d",&iMatrix[i][j]); 
    } 
  } 
  fclose(file1);
    
  fprintf(file2,"%f\n",eTo);
  fprintf(file3,"%d\n %d\n ",imax, jmax);
  fprintf(file4,"%d\n %d\n ",imax, jmax);
   

  if(c*m > iBurnin){
    fprintf(file2,"%ld\n",iTotalsample-(iBurnin/iIteration));
    fprintf(file3,"%ld\n",iTotalsample-(iBurnin/iIteration));
    fprintf(file4,"%ld\n",iTotalsample-(iBurnin/iIteration)); 
    printf("%ld\n",iTotalsample-(iBurnin/iIteration));
  }
  else{
    fprintf(file3,"%ld\n",iTotalsample);
    fprintf(file4,"%ld\n",iTotalsample);
    fprintf(file2," \t %ld\n",iTotalsample);
  }
  /* Initial permutation, row */
    
  /* fprintf(file2,"A kezdeti sorpermutacio\n");*/
  printf("First rowpermutation\n");
  if(cPermutacio == 0){  
    srandom(335);
    
    for(s=0; s < imax; s++){
      iSor[s] = -1;
    }
    
    for(s=0;s<imax;s++){
      while(iSor[(iTemp = iIntrand(imax))] != -1);
      iSor[iTemp] = s;
    }
  }
  /* Ha van, beolvassa a permutaciot*/
  else{
    for(s=0; s < imax; s++){
      fscanf(file5,"%d",&iSor[s]);
    }
  }

  for(s=0;s<imax;s++){
    /* fprintf(file2,"%d\n",iSor[s]);*/
    printf("%d\n",iSor[s]);
  }
    
  /* Initial permutation, column */
    
  /* fprintf(file2,"A kezdeti oszloppermutacio\n"); */
  printf("First columnpermutation\n");
    
  if(cPermutacio == 0){ 
    srandom(335);
    for(o = 0; o < jmax; o++){
      iOszlop[o] = -1;
    }
    
    for(o=0;o < jmax;o++){
      while(iOszlop[(iTemp = iIntrand(jmax))] != -1);
      iOszlop[iTemp]= o;
    }
  }
  else{
    for(o = 0; o < jmax; o++){
      fscanf(file5,"%d",&iOszlop[o]);
    }
  }
  for(o=0;o<jmax;o++){
    /*	fprintf(file2,"%d\n",iOszlop[o]);*/
    printf("%d\n",iOszlop[o]);
  }
    
    
  /* homerseklet normalizalasa */
    
  eT =0.0;
  for(j = 0; j < jmax; j++){
    for(i = 0; i < imax - 1; i++){
      for(k = i + 1; k < imax; k++){
	eT += fabs((double)(iMatrix[i][j] - iMatrix[k][j]))/((double)imax * (double)jmax);
      }
    }
  }
  eT =0.0;
  for(i = 0; i < imax; i++){
    for(j = 0; j < jmax - 1; j++){
      for(k = j + 1; k < jmax; k++){
	eT += fabs((double)(iMatrix[i][j] - iMatrix[i][k]))/((double)imax * (double)jmax);
      }
    }
  }
    
  eT *= eTo;
  printf("eT: %e\n",eT);
    
  eEnergyOld = eEnergy(iMatrix,imax,jmax,iSor,iOszlop); 
  printf("first energy: %f\n",eEnergyOld);
    
  /* MCMC */    

  for(m=0;m<iTotalsample;m++){ 
    for(c=0;c<iIteration;c++){ 
	    
      eSordiff = eProposalsor(iMatrix,iSor,iSorNew,imax,jmax);
	    
      eEnergyNew = eEnergyOld+eSordiff; 	 
      /*	  
		 if(eEnergyNew != eEnergy(iMatrix,imax,jmax,iSorNew,iOszlop)){
		 printf("Huha!\n");
		 }
      */
      eX=(double)random()/(double)RAND_MAX;
      if(exp(-(eEnergyNew - eEnergyOld)/eT) > eX){ 
	/* acceptance */
	eEnergyOld = eEnergyNew;
	for(s = 0; s < imax; s++){
	  iSor[s] = iSorNew[s];
	}
      }
	    
	    
      eOszlopdiff = eProposaloszlop(iMatrix,iOszlop,iOszlopNew,imax,jmax);
      eEnergyNew = eEnergyOld+eOszlopdiff; 
      /*
	if(eEnergyNew != eEnergy(iMatrix,imax,jmax,iSor,iOszlopNew)){
	printf("Huha! oszlop...\n");
	}
      */
      eX=(double)random()/(double)RAND_MAX;
      if(exp(-(eEnergyNew - eEnergyOld)/eT) > eX){ 
	/* acceptance */
	eEnergyOld = eEnergyNew;
		
	for(o = 0; o < jmax; o++){
	  iOszlop[o] = iOszlopNew[o];
	}
      }
	    
    }
    if(iBurnin > iIteration){
      if(c*m > iBurnin){
	fprintf(file2,"rowpermutation:\t "); 
	/*  printf("sorpermutacio\n"); */
	    
	for(s=0;s<imax;s++){ 
	  fprintf(file2,"%d ",iSor[s]);
	  fprintf(file3,"%d ",iSor[s]); 
	  /*      printf("%d\n",iSor[s]);*/
	} 
	fprintf(file3,"\n");
	fprintf(file2,"\t columnpermutation:\t "); 
	/*    printf("oszloppermutacio\n"); */
	for(o=0;o<jmax;o++){ 
	  fprintf(file2,"%d ",iOszlop[o]);
	  fprintf(file4, "%d ",iOszlop[o]);
	  /*      printf("%d\n",iOszlop[o]); */
	} 
	fprintf(file2,"\t energy:\t %f\n",eEnergyOld);
	    
	fprintf(file4,"\n"); 
	    
	    
	printf("%d %f\n",m,eEnergyOld);
      }
    }
    else{
      fprintf(file2,"rowpermutation:\t "); 
      /*  printf("sorpermutacio\n"); */
	  
      for(s=0;s<imax;s++){ 
	fprintf(file2,"%d ",iSor[s]);
	fprintf(file3,"%d ",iSor[s]); 
	/*      printf("%d\n",iSor[s]);*/
      } 
      fprintf(file3,"\n");
      fprintf(file2,"\t columnpermutation:\t "); 
      /*    printf("oszloppermutacio\n"); */
      for(o=0;o<jmax;o++){ 
	fprintf(file2,"%d ",iOszlop[o]);
	fprintf(file4, "%d ",iOszlop[o]);
	/*      printf("%d\n",iOszlop[o]); */
      } 
      fprintf(file2,"\t energy:\t %f\n",eEnergyOld);
	  
      fprintf(file4,"\n"); 
	    
	  
      printf("%d %f\n",m,eEnergyOld);
    }
    /* printf("ujenergia %f\n",eEnergyNew);
       printf("SorDiff %f\n",eOszlopdiff);*/
	
  }  
  return 0; 
} 

double eEnergy(int iMatrix[MAX][MAX], int imax, int jmax, int iSor[MAX], int iOszlop[MAX]){ 
    
  
  double eE,SSQ1,SSQ2;
  int s,o; 
  
  SSQ1=0; 
  SSQ2=0; 
  s=0; 
  o=0; 

  for(s=0;s<imax-1;s++){ 
    for(o=0;o<jmax;o++){ 
      SSQ1 += fabs((double)(iMatrix[iSor[s]][o]-iMatrix[iSor[s+1]][o])); 
    } 
  } 

  /*tukor-szamitas*/

  for(o=0;o<jmax;o++){
    SSQ1 += fabs((double)(iMatrix[iSor[0]][o] - iMatrix[iSor[1]][o])) + 
      fabs((double)(iMatrix[iSor[imax - 1]][o] - iMatrix[iSor[imax - 2]][o]));
  }
  
  for(s=0;s<imax;s++){ 
    for(o=0;o<jmax-1;o++){ 
      SSQ2 += fabs((double)(iMatrix[s][iOszlop[o]]-iMatrix[s][iOszlop[o+1]])); 
    } 
  } 

  /*tukor-szamitas*/

  for(s=0;s<imax;s++){
    SSQ2 += fabs((double)(iMatrix[s][iOszlop[0]] - iMatrix[s][iOszlop[1]])) + 
      fabs((double)(iMatrix[s][iOszlop[jmax - 1]] - iMatrix[s][iOszlop[jmax - 2]]));
  }

  eE=SSQ1+SSQ2; 
  
  return(eE); 
} 

double eProposalsor(int iMatrix[MAX][MAX],
		    int iSor[MAX],
		    int iSorNew[MAX],
		    int imax,
		    int jmax){ 
  
  int d,e,iI,iJ;
  int iIntrand(int);
  void Swap(int*,int*);
  double eDiff;

  d=iIntrand(imax);


  e=iIntrand(imax-1);
  if(e >= d){
    e++;
  }
  else{
    Swap(&d,&e);
  }

  /*  printf("d: %d, e: %d\n",d,e);*/
  eDiff = 0.0;
  for(iJ = 0; iJ < jmax; iJ++){
    if(d > 1){
      eDiff += fabs((double)(iMatrix[iSor[e]][iJ] - iMatrix[iSor[d - 1]][iJ])) -
	fabs((double)(iMatrix[iSor[d]][iJ] - iMatrix[iSor[d - 1]][iJ]));
    }
    else if(d == 0){
      eDiff += fabs((double)(iMatrix[iSor[e]][iJ] - iMatrix[iSor[e - 1]][iJ])) -
	fabs((double)(iMatrix[iSor[d]][iJ] - iMatrix[iSor[d + 1]][iJ]));
    }
    else{
      eDiff += 2.0 * (fabs((double)(iMatrix[iSor[e]][iJ] - iMatrix[iSor[d - 1]][iJ])) -
	              fabs((double)(iMatrix[iSor[d]][iJ] - iMatrix[iSor[d - 1]][iJ])));
    }

    if(e < imax - 2){
      eDiff += fabs((double)(iMatrix[iSor[d]][iJ] - iMatrix[iSor[e + 1]][iJ])) -
	fabs((double)(iMatrix[iSor[e]][iJ] - iMatrix[iSor[e + 1]][iJ]));    
    }
    else if(e == imax - 1){
      eDiff += fabs((double)(iMatrix[iSor[d]][iJ] - iMatrix[iSor[d + 1]][iJ])) -
	fabs((double)(iMatrix[iSor[e]][iJ] - iMatrix[iSor[e - 1]][iJ]));
    }
    else{
      eDiff += 2.0 * (fabs((double)(iMatrix[iSor[d]][iJ] - iMatrix[iSor[e + 1]][iJ])) -
	              fabs((double)(iMatrix[iSor[e]][iJ] - iMatrix[iSor[e + 1]][iJ])));
    }
  }

  for(iI = 0 ; iI < d; iI++){
    iSorNew[iI] = iSor[iI];
  }
  for(iI = d; iI <= e; iI++){
    iSorNew[iI] = iSor[e + d - iI];
  } 
  for(iI = e + 1; iI < imax; iI++){
    iSorNew[iI] = iSor[iI];
  }

  return(eDiff);
}

double eProposaloszlop(int iMatrix[MAX][MAX],
		       int iOszlop[MAX], 
		       int iOszlopNew[MAX],
		       int imax,
		       int jmax){ 
  
  int d,e,iI,iJ;
  int iIntrand(int);
  void Swap(int*,int*);
  double eDiff;

  d = iIntrand(jmax);

  e = iIntrand(jmax-1);
  if(e >= d){
    e++;
  }
  else{
    Swap(&d,&e);
  }
  /*  printf("d: %d, e: %d\n",d,e);*/

  eDiff = 0.0;
  for(iI = 0; iI < imax; iI++){
    if(d > 1){
      eDiff += fabs((double)(iMatrix[iI][iOszlop[e]] - iMatrix[iI][iOszlop[d - 1]])) -
	fabs((double)(iMatrix[iI][iOszlop[d]] - iMatrix[iI][iOszlop[d - 1]]));
    }
    else if(d == 0){
      eDiff += fabs((double)(iMatrix[iI][iOszlop[e]] - iMatrix[iI][iOszlop[e - 1]])) - 
	fabs((double)(iMatrix[iI][iOszlop[d]] - iMatrix[iI][iOszlop[d + 1]]));
    }
    else{
      eDiff += 2.0 * (fabs((double)(iMatrix[iI][iOszlop[e]] - iMatrix[iI][iOszlop[d - 1]])) -
	              fabs((double)(iMatrix[iI][iOszlop[d]] - iMatrix[iI][iOszlop[d - 1]])));
    }
    if(e < jmax - 2){
      eDiff += fabs((double)(iMatrix[iI][iOszlop[d]] - iMatrix[iI][iOszlop[e + 1]])) -
	fabs((double)(iMatrix[iI][iOszlop[e]] - iMatrix[iI][iOszlop[e + 1]]));
    }
    else if(e == jmax - 1){
      eDiff += fabs((double)(iMatrix[iI][iOszlop[d]] - iMatrix[iI][iOszlop[d + 1]])) -
	fabs((double)(iMatrix[iI][iOszlop[e]] - iMatrix[iI][iOszlop[e - 1]]));      
    }
    else{
      eDiff += 2.0 * (fabs((double)(iMatrix[iI][iOszlop[d]] - iMatrix[iI][iOszlop[e + 1]])) -
                      fabs((double)(iMatrix[iI][iOszlop[e]] - iMatrix[iI][iOszlop[e + 1]])));
    }
  }

  for(iJ = 0; iJ < d; iJ++){
    iOszlopNew[iJ] = iOszlop[iJ];
  }
  for(iJ = d; iJ <= e; iJ++){
    iOszlopNew[iJ] = iOszlop[d + e - iJ];
  }
  for(iJ = e + 1; iJ < jmax; iJ++){
    iOszlopNew[iJ] = iOszlop[iJ];
  }

  return(eDiff);
}

int iIntrand(int iN){

  double eZ;

  eZ = (double)random() * (double)iN / (double)RAND_MAX;
  if(eZ >= iN){
    eZ = iN - 1;
  }
  if(eZ < 0){
    eZ = 0;
  }
  return((int)floor(eZ));
}

void Swap(int* iI, int* iJ){

  int iK;

  iK = *iI;
  *iI = *iJ;
  *iJ = iK;
}
